# Checks for DTML objects, such as we are able to do

# Each function will be passed the object from Zope,
# so at this point do some work...
#
# Functions should return 1 for a success and 0 for
# the error mentioned to be returned

from DocumentTemplate import DT_HTML
from TreeDisplay.TreeTag import Tree

import re

mth_meta_types = ['DTML Method', 'Filesystem DTML Method']
doc_meta_types = ['DTML Document', 'Filesystem DTML Document']

#######################################
# utility functions

def _parse(obj):
    h = DT_HTML.HTML()
    h.munge(obj.document_src())
    return h

def _findRe(obj, regex):
    if regex.search(obj.document_src()):
        return 0
    return 1

#######################################
# rules

rules = []

def dtmlTree(obj):
    o = _parse(obj)
    for i in o._v_blocks:
        if isinstance(i, Tree):
            del o
            return 0
    return 1


rules.append(
    {
        'name':'Use of sequence-index',
        'meta_type':doc_meta_types + mth_meta_types,
        'level':0,
        'function':(_findRe, re.compile('_\[sequence-')),
        'msg':'The use of sequence- is deprecated, use prefix for dtml-in',
    }
    )

rules.append(
    {
        'name':'DTML tree in a DTML Document',
        'meta_type':doc_meta_types,
        'level':1,
        'function':dtmlTree,
        'msg':'dtml-tree does not work in a DTML Document',
    }
    )
